%Do databze Prologu meme vkldat fakta a pravidla i za bhu programu.
%Tm v podstat lze suplovat globln promnn, ale je teba zvit,
%kdy jsou pravy databze oprvnn.
%Pidn faktu nebo pravidla by mlo reprezentovat nov nabytou znalost,
%ne pouze njak pznak, kter se nm hod k pouit ve vlastnm algoritmu.

%Vloen faktu do databze.
%Bez assert by Prolog hlsil undefined procedure.
test1 :-
  assert(pivo),
  pivo.

%Fakt lze vloit i vcekrt a pak po jednom odebrat.
test2 :-
  assert(pivo),
  assert(pivo),
  assert(pivo),
  !,
  retract(pivo), write('dalsi pivo'), nl, fail.

%Libovoln fakt lze kdykoliv odebrat.
test3 :-
  assert(pivo),
  assert(vino),
  assert(rum),
  assert(vodka),
  assert(slivovice),
  retract(rum).

%Fakt zstv v databzi po celou dobu bhu programu, dokud nen odstrann.
test4a :- assert(pivo).
test4b :- retract(pivo).

%Pi opakovanm vyhodnocovn fakt z databze stdav odebr a pidv.
test5 :-
  (retract(vyhodnoceno), write('Sude vyhodnoceni'), nl); assert(vyhodnoceno).

%Do databze lze vkldat libovoln klauzule.
test6 :-
  assert((alkohol(X) :- pivo(X))),
  assert((alkohol(X) :- vino(X))),
  assert(pivo('Pilsner Urquell')),
  assert(pivo('Gambrinus')),
  assert(vino('Champagne')),
  alkohol('Gambrinus').

test6a :- alkohol(voda).

%Pidvn na zatek databze.
test7 :-
  asserta((vypis :- write(prvni))),
  asserta((vypis :- write(druhy))),
  asserta((vypis :- write(treti))),
  vypis.
  
%Pidvn na konec databze (tot, jako assert).
test8 :-
  assertz((vypis :- write(prvni))),
  assertz((vypis :- write(druhy))),
  assertz((vypis :- write(treti))),
  vypis.

%Vymazn celho prediktu z databze.
test9 :-
  assertz((vypis :- write(prvni))),
  assertz((vypis :- write(druhy))),
  assertz((vypis :- write(treti))),
  retractall(vypis),
  vypis.

%Vymazn pouze jednoho pravidla z databze
test10 :-
  assertz((vypis :- write(prvni))),
  assertz((vypis :- write(druhy))),
  assertz((vypis :- write(treti))),
  retractall((vypis :- write(prvni))),
  vypis.

%Vymazn podle funktoru a arity
test11 :-
  assertz((vypis :- write(prvni))),
  assertz((vypis :- write(druhy))),
  assertz((vypis :- write(treti))),
  abolish(vypis/0),
  vypis.

%recordz(Key,Term,Ref)
%Uloen Termu pod klem Key a uniktnm identifiktorem Ref
test12 :-
  recordz(cisla,1,0),
  recordz(cisla,2,1),
  recordz(cisla,3,2),
  %%% recorded(cisla,X,Y), - toto shod interpret
  ( %Vpis vech hodnot pod klem
    recorded(cisla,X,_),
    write(X), fail
  );
  ( %K vymazn potebujeme zjistit i identifiktor
    recorded(cisla,X,Y),
    write(X), erase(Y), fail
  ).

%Pokud identifiktor zznamu nespecifikujeme, lze ho nsledn pout k odstrannn
%zznamu, ale snaha o jinou prci s touto hodnotou pravdpodobn povede k selhn.
test13 :-
  recordz(cisla,1,_),
  recordz(cisla,2,_),
  recordz(cisla,3,_),
  recorded(cisla,1,Y),
  %%% write(Y), - toto shod interpret
  %%% Y1 is Y + 1, - toto taky
  erase(Y),
  recorded(cisla,X,_),
  write(X).

%Ukldn bez kl moc nefunguje
test14 :-
  recordz(_,hodnota,0),
  recorded(_,X,0), % Tento predikt nen splnn
  recorded(_,X,_). % Toto funguje, ale zznam nelze dohledat.
  