%Opertor ztotonn - pokud je alespo jeden term voln promnn, provede
%navzn a je splnn, jinak porovnv termy na shodu.
test1 :-
  A = 1, %Volnou promnnou lze navzat na slo.
  A = B, %Ztotonnm voln a vzan promnn jsou ob navzny na stejn slo.
  write(B). %Vype "1".

test2 :-
  A = 1,
  A = 2. %Promnn u je vzna na slo 1 a to se neshoduje s slem 2.

%Meme nejprve navzat voln promnn a potom je navzat na term.
test3 :-
  A = B,
  A = 1,
  write(B). %I tady je promnn navzna na slo (vype "1").

%Zde ani jedna promnn u nen voln a vzan termy nejsou shodn.
test4 :-
  A = 1,
  B = 2,
  A = B.
  
%Zde jsou ob promnn vzny na stejn term.
test5 :-
  A = 1,
  B = 1,
  A = B.

%Postupn zkou navazovat A na rzn sla, dokud se neshodne s B.
test6 :-
  (A = 1; A = 2; A = 3),
  B = 3,
  A = B,
  write(A). %Vype "3"
  %Vimnte si, e nezle na tom, e navzan promnn B je v kdu a po navzn
  %promnn A, dky backtrackingu.

%Opertor porovnn term na neshodu.
%Pokud je alespo jeden voln promnn, nen splnn.
%Stejnou funkci m not(A = B)
test7 :-
  A = 1,
  B = 2,
  A \= B.

%Pokud "=" nave B na A, pro nezstane navzna?
%Podmnka not(A = B) v tom ppad urit nen splnna, provd se tedy
%backtracking a navzn je anulovno.
test8 :-
  (A = 1, not((A = B, write(B)))); %Ped backtrackingem je promnn navzna.
  write(B). %Promnn je voln, write jej vnitn identifiktor.
%Vimnte si, e argument "not" mus bt zvl᚝ uzvorkovn, jinak by byl chpn
%jako dva argumenty, a ne jako "argument1 && argument2" - rka m v prologu dva
%vznamy, kter se mohou dostat do konfliktu, a jako oddlova argument
%m pednost.

%Opertor ?= zjiuje, zda lze promnn navzat, ale neudl to.
%Pro ostatn termy funguje jako =
test9 :-
  A = 1,
  A ?= B,
  write(B). %Promnn B je voln.

%Stejnou funkci jako ?= m not(not(A = B)).
test10 :-
  A = 1,
  not(not(A = B)),
  write(B). %Promnn B je voln.

%Pokud se vm zd divn, e promnn B zstala nenavzna, pestoe podmnka je
%splnna, meme vnitn st rozepsat pomoc vlastnho pravidla:
obsazeno(A,B) :- not(A = B). %Podmnka nen splnna a backtracking nenalezne
                %dal monost - predikt nen splnn a promnn nenavzny.
test11 :-
  not(obsazeno(A,B)), %Pouze obrac "no" na "yes".
  write(B).

%Pokud byste "=" chpali jako bn piazen, narazte na dal pekvapen:
%B je vzna na term A+1, co nen tot, co hodnota 2.
test12 :-
  A=1,
  B=A+1,
  B=2.

%Dokonce ani 1+1 nen tot, co hodnota 2.
test13 :-
  A=1+1,
  A=2.

%Opertor "is" nenavazuje promnnou na term, ale jeho aritmetickou hodnotu
%B je vzna na hodnotu 2, tento predikt je tedy splnn.
test14 :-
  A=1,
  B is A+1,
  B=2.

%A je navzna na 1, co nen 2, predikt proto nen splnn. Ani opertor "is" neme
%zmnit vazbu promnn.
test15 :-
  A is 1,
  A is 2.

%Opertory <, >, =< a >= porovnvaj hodnoty aritmetickch vraz.
%Opertory @<, @>, @=< a @>= porovnvaj termy abecedn, resp. podle hodnot znak.
%Nsledujc cl je tedy splnn:
test16 :-
  (1+3 > 2+1),
  (1+3 @< 2+1).
  