%Pole B-Prologu jsou sice zaloena na vnoench strukturch, ale nejsou s nimi
%identick:
test1 :-
  new_array(A,[3,3]),
  B = ((B11,B12,B13),(B21,B22,B23),(B31,B32,B33)),
  write(A), ((is_array(A), write(' - je to pole'), nl); (write(' - neni to pole'), nl)),
  write(B), ((is_array(B), write(' - je to pole'), nl); (write(' - neni to pole'), nl)).

%Zajmavost - posledn vnoen struktura je pesunuta o rove n.
%Toto srovnn proto projde.
test2 :-
  (a,(b,c,d)) == (a,b,c,d).

%Dokonce i toto porovnn projde.
test3 :-
  L = (b,c,d),
  (a,L) == (a,b,c,d).

%Toto ale neprojde.
test4 :-
  ((a,b),(c,d)) = (a,b,c,d).

%Vechny prvky pole jsou inicializovny jako voln promnn.
%K prvkm lze pistoupit prediktem arg, ale nen to pli elegantn.
%V ppad vcerozmrnho pole by ho bylo nutno pout opakovan.
test5 :-
  new_array(A,[3]),
  arg(1,A,a), arg(2,A,b), arg(3,A,c),
  write('Cele pole: '), write(A), nl,
  arg(2,A,X), write('Druhy prvek: '), write(X).

%Alternativn pstup k poli pomoc hranatch zvorek: A[I,J,...,K].
%Ped kompilac je nahrazeno vrazem A^[I,J,...,K].
%Pro pstup k poli funguje pouze v aritmetickm vrazu, v pravdivostnm vrazu,
%nebo jako argument opertoru @= (speciln varianta = k tomuto elu).
test_prvku(A,I,_,Vyhovuje) :- write(1), I > A^length, Vyhovuje is 0.
test_prvku(A,I,Test,Vyhovuje) :- write(2), arg(I,A,A_I), compound(A_I), test_prvku(A_I,Test,Vyhovuje).
test_prvku(A,I,Test,Vyhovuje) :- write(3), I2 is I + 1, test_prvku(A,I2,Test,Vyhovuje2), ((arg(I,A,A_I), call(Test,A_I), Vyhovuje is Vyhovuje2 + 1); true).
test_prvku(A,Test,Vyhovuje) :- write(4), test_prvku(A,1,Test,Vyhovuje).
jednociferny(A) :- A < 10.
test6 :-
  new_array(A,[3,3]),
  A[1,1] @= 2,
  A[1,2] @= 3,
  A[1,3] @= 5,
  A[2,1] @= 7,
  A[2,2] @= 11,
  A[2,3] @= 13,
  A[3,1] @= 17,
  A[3,2] @= 19,
  A[3,3] @= 23,
  write(A), nl,
  test_prvku(A,jednociferny,Vyhovuje),
  write('Vyhovuje: '), write(Vyhovuje).

%Lze pout i pro seznamy:
test7 :-
  A = [_,_,_],
  A[1] @= 2,
  A[2] @= 3,
  A[3] @= 5,
  write(A).

%Alternativn lze pro vcerozmrn pole (nap. tam, kde uveden pstup nefunguje)
%pout predikty a2_get(A,I,J,Aij) a a3_get(A,I,J,K,Aijk).

%Vytvoen jednorozmrn seznam vech prvk pole. Nelze pout opan.
%Je pouita alternativn inicializace pole.
test8 :-
  A = [](
    [](
      [](2,3,5),
      [](7,11,13,17),
      [](19,23)
    ),
    [](29,31,37)
  ),
  array_to_list(A,L),
  write(L).
  