% Ukradeno z:
% http://www.augustana.ca/~jmohr/courses/common/csc370/lecture_notes/prolog_examples/zebra_puzzle.html

%  -*-prolog-*-
%
%  Einsteinova hdanka: kdo chov rybiky?
%
%  Fakta jsou uvedena v komentch programu.
%
%  een od Jonathana Mohra (mohrj@augustana.ca)
%  Augustana University College, Camrose, AB, Canada  T4V 2R3


%  Tento cl zobraz pouze een hdanky.
vyres :- vyres(_).

%  Tento cl zobraz cel postup een.
vyres(Domy) :-

% Je pt dom.
% Kad dm m jinou barvu.
% V kadm dom ije osoba rozdln nrodnosti.
% Kad chov jin zve.
% Kad pije jin npoj.
% Kad kou jin cigarety.

% (Tato omezen lze uplatnit teprve ve chvli, kdy u mme navznu vtinu
% promnnch, viz ne.)

% B... barvy, N... nrodnosti, Z... zvata, P... npoje, C... cigarety
% Poad vnoench seznam odpovd poad dom, zleva doprava.
    Domy = [
          [B1,N1,Z1,P1,C1],
          [B2,N2,Z2,P2,C2],
          [B3,N3,Z3,P3,C3],
          [B4,N4,Z4,P4,C4],
          [B5,N5,Z5,P5,C5]
        ],

% Anglian ije v ervenm dom.
% member je standardn predikt prologu, proto nen v programu definovn.
% Udv, e nkde mezi domy (v seznamu seznam) je dm s danou vlastnost.
    member([cerveny, anglican, _, _, _], Domy),
% vd chov psa.
    member([_, sved, pes, _, _], Domy),
% Dn pije aj.
    member([_, dan, _, caj, _], Domy),
% Zelen dm je hned nalevo od blho.
% Vimnte si zkrcenho zpisu namsto [zeleny, _, _, _, _] apod.
% v ppad, e ns vechny zbvajc prvky seznam nezajmaj
    nalevo([zeleny |_], [bily |_], Domy),
% Obyvatel zelenho domu pije kvu.
    member([zeleny, _, _, kava, _], Domy),
% Ten, co kou Pall Mall, chov ptka.
% Vimnte si atomu v uvozovkch, aby mohl zanat velkm psmenem
% a obsahovat mezeru.
    member([_, _, ptak, _, 'Pall Mall'], Domy),
% Obyvatel lutho domu kou Dunhill.
    member([zluty, _, _, _, 'Dunhill'], Domy),
% Ten, co ije ve stednm dom, pije mlko.
    P3 = mleko,
% Nor ije v prvnm dom.
    N1 = nor,
% Ten, co kou Blend, ije vedle toho, co chov koku.
    vedle([_, _, _, _, 'Blend'], [_, _, kocka |_], Domy),
% Ten, co chov kon, ije vedle toho, co kou Dunhill.
    vedle([_, _, _, _, 'Dunhill'], [_, _, kun |_], Domy),
% Ten, co kou Blue Master, pije pivo.
    member([_, _, _, pivo, 'Blue Master'], Domy),
% Nmec kou Prince.
    member([_, nemec, _, _, 'Prince'], Domy),
% Nor ije vedle modrho domu.
    vedle([_, nor |_], [modry |_], Domy),
% Ten, co kou Blend, m souseda, kter pije vodu.
    vedle([_, _, _, voda,_], [_, _, _, _, 'Blend'], Domy),

%
% Ve skutenosti mme k dispozici dostatek omezen, abychom nemuseli
% provdt nsledujc kontroly - zkladn podmnky budou zaruen
% splnny. Jsou uvedeny pro plnost a proto, e ped eenm hdanky
% bn nevme, zda je potebujeme.
%
% Kad dm m jinou barvu.
    B1 \== B2, B1 \== B3, B1 \== B4, B1 \== B5,
    B2 \== B3, B2 \== B4, B2 \== B5,
    B3 \== B4, B3 \== B5, B4 \== B5,
% V kadm dom ije osoba rozdln nrodnosti.
    N1 \== N2, N1 \== N3, N1 \== N4, N1 \== N5,
    N2 \== N3, N2 \== N4, N2 \== N5,
    N3 \== N4, N3 \== N5, N4 \== N5,
% Kad chov jin zve.
    Z1 \== Z2, Z1 \== Z3, Z1 \== Z4, Z1 \== Z5,
    Z2 \== Z3, Z2 \== Z4, Z2 \== Z5,
    Z3 \== Z4, Z3 \== Z5, Z4 \== Z5,
% Kad pije jin npoj.
    P1 \== P2, P1 \== P3, P1 \== P4, P1 \== P5,
    P2 \== P3, P2 \== P4, P2 \== P5,
    P3 \== P4, P3 \== P5, P4 \== P5,
% Kad kou jin cigarety.
    C1 \== C2, C1 \== C3, C1 \== C4, C1 \== C5,
    C2 \== C3, C2 \== C4, C2 \== C5,
    C3 \== C4, C3 \== C5, C4 \== C5,

% Kdo chov rybiky?
    member([_, Kdo, rybicky, _, _], Domy),
    write('Rybicky chova '), write(Kdo), write('.\n').
% Vimnte si, e a tady kon klauzuje vyres(Domy). Vechna pravidla jsou
% oddlena rkou, plat pro n tedy "a zrove".

% Tento predikt ur (pomoc rekurze), zda prvek D1 je v seznamu nalevo od D2.
nalevo(D1, D2, [D1, D2 |_]).
nalevo(D1, D2, [_| Zbytek ]) :- nalevo(D1, D2, Zbytek).

% Ur (vyuitm prediktu nalevo), zda prvek D1 v seznamu soused s D2.
vedle(D1, D2, Domy) :- nalevo(D1, D2, Domy).
vedle(D1, D2, Domy) :- nalevo(D2, D1, Domy).