% -*-prolog-*-
%
%  Einsteinova hdanka: kdo chov rybiky?
%
%  Toto een pouv seznam barev, nrodnost, zvat, pit a cigaret, a
%  spolh na to, e loha je dostaten vymezena, aby uniktnost prvk byla
%  zaruena. To plat v ppad tto hdanky, ale nemus to platit obecn.
%
%  Jonathan Mohr (mohrj@augustana.ab.ca)
%  Augustana University College, Camrose, AB, Canada  T4V 2R3

vyres :- vyres(_).
vyres([Barvy, Narodnosti, Zvirata, Piti, Cigarety]) :-
% Je pt dom.
% Kad dm m jinou barvu.
% (Nsledujc k pouze, e mme 5 barev, jejich uniktnost nen automaticky
% zaruena)
	Barvy = [_,_,_,_,_],
% V kadm dom ije osoba rozdln nrodnosti.
	Narodnosti = [_,_,_,_,_],
% Kad chov jin zve.
	Zvirata = [_,_,_,_,_],
% Kad pije jin npoj.
	Piti = [_,_,_,_,_],
% Kad kou jin cigarety.
	Cigarety = [_,_,_,_,_],
% Anglian ije v ervenm dom.
	odpovida(cerveny, Barvy, anglican, Narodnosti),
% vd chov psa.
	odpovida(sved, Narodnosti, pes, Zvirata),
% Dn pije aj.
	odpovida(dan, Narodnosti, caj, Piti),
% Zelen dm je hned nalevo od blho.
	nalevo(zeleny, bily, Barvy),
% Obyvatel zelenho domu pije kvu.
	odpovida(zeleny, Barvy, kava, Piti),
% Ten, co kou Pall Mall, chov ptka.
	odpovida(ptak, Zvirata, 'Pall Mall', Cigarety),
% Obyvatel lutho domu kou Dunhill.
	odpovida(zluty, Barvy, 'Dunhill', Cigarety),
% Ten, co ije ve stednm dom, pije mlko.
	Piti = [_, _, mleko, _, _],
% Nor ije v prvnm dom.
	Narodnosti = [nor | _],
% Ten, co kou Blend, ije vedle toho, co chov koku.
	sousedi('Blend', Cigarety, kocka, Zvirata),
% Ten, co chov kon, ije vedle toho, co kou Dunhill.
	sousedi('Dunhill', Cigarety, kun, Zvirata),
% Ten, co kou Blue Master, pije pivo.
	odpovida(pivo, Piti, 'Blue Master', Cigarety),
% Nmec kou Prince.
	odpovida(nemec, Narodnosti, 'Prince', Cigarety),
% Nor ije vedle modrho domu.
	sousedi(nor, Narodnosti, modry, Barvy),
% Ten, co kou Blend, m souseda, kter pije vodu.
	sousedi(voda, Piti, 'Blend', Cigarety),
% Kdo chov rybiky?
	odpovida(rybicky, Zvirata, Kdo, Narodnosti),
	format("Rybicky chova ~w.\n", Kdo), !.

% Tento predikt (s vyuitm rekurze) ur, zda se prvek B nchz v seznamu T1
% na stejn pozici, jako prvek B v seznamu T2
odpovida(A, [A|_], B, [B|_]).
odpovida(A, [_|T1], B, [_|T2]) :- odpovida(A, T1, B, T2).

% Zjist, zda prvek L1 je v seznamu nalevo od L2.
nalevo(L1, L2, [L1, L2 |_]).
nalevo(L1, L2, [_| Zbytek ]) :-
    nalevo(L1, L2, Zbytek).
    
% Zjist, zda A je v seznamu T1 na pozici, kter se o jedniku li od pozice B
% v seznamu T2 (tedy me, ale nemus pracovat s jednm seznamem!)
sousedi(A, [A|_], B, [_,B|_]).
sousedi(A, [_,A|_], B, [B|_]).
sousedi(A, [_|T1], B, [_|T2]) :-
    sousedi(A, T1, B, T2).